workflow:
  rules:
    - if: $CI_COMMIT_BRANCH != "main" &&  $CI_PIPELINE_SOURCE != "merge_request_event"
      when: never
    - when: always

stages:
  - test
  - build
  - deploy


variables:
  ENDPOINT_PORT: "3000"
  FRONT_PORT: "3000"
  PRODUCTS_PORT: "3001"
  CART_PORT: "3002"
  MICRO_SERVICE_FRONTEND: "frontend"
  MICRO_SERVICE_PRODUCTS: "products"
  MICRO_SERVICE_SHOPPING_CART: "shopping-cart"
  FRONT_TAG_LATEST: $CI_REGISTRY_IMAGE/frontend:latest
  FRONT_TAG_COMMIT: $CI_REGISTRY_IMAGE/frontend:$CI_COMMIT_SHORT_SHA
  PRODUCTS_TAG_LATEST: $CI_REGISTRY_IMAGE/products:latest
  PRODUCTS_TAG_COMMIT: $CI_REGISTRY_IMAGE/products:$CI_COMMIT_SHORT_SHA
  SHOPPING_CART_TAG_LATEST: $CI_REGISTRY_IMAGE/shopping-cart:latest
  SHOPPING_CART_TAG_COMMIT: $CI_REGISTRY_IMAGE/shopping-cart:$CI_COMMIT_SHORT_SHA
  CI_DEBUG_TRACE: "true"

build_frontend:
  stage: build
  services:
    - docker:dind
  tags:
    - linode
    - remote
    - shell
  before_script:
    - cd frontend
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $FRONT_TAG_COMMIT -t $FRONT_TAG_LATEST .
    - docker push $FRONT_TAG_COMMIT
    - docker push $FRONT_TAG_LATEST
  only:
    changes:
      - "frontend/**/*"


build_products:
  stage: build
  services:
    - docker:dind
  tags:
    - linode
    - remote
    - shell
  before_script:
    - cd products
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $PRODUCTS_TAG_COMMIT -t $PRODUCTS_TAG_LATEST .
    - docker push $PRODUCTS_TAG_COMMIT
    - docker push $PRODUCTS_TAG_LATEST
  only:
    changes:
      - "products/**/*"

build_shopping_cart:
  stage: build
  services:
    - docker:dind
  tags:
    - linode
    - remote
    - shell
  before_script:
    - cd products
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $SHOPPING_CART_TAG_COMMIT -t $SHOPPING_CART_TAG_LATEST .
    - docker push $SHOPPING_CART_TAG_COMMIT
    - docker push $SHOPPING_CART_TAG_LATEST
  only:
    changes:
      - "shopping-cart/**/*"


deploy_frontend:
  stage: deploy
  tags:
    - linode
    - remote
    - shell
  before_script:
    - chmod og= $ID_RSA
  script:
    - scp -i $ID_RSA -o StrictHostKeyChecking=no ./docker-compose.yml $SERVER_USER@$SERVER_IP:/home/dabiko
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "
      docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY &&

      docker pull $FRONT_TAG_COMMIT &&
      docker container rm -f $CI_REGISTRY_IMAGE || true &&

      export DC_IMAGE_NAME=$CI_REGISTRY_IMAGE &&
      export DC_IMAGE_TAG=$FRONT_TAG_COMMIT &&
      export DC_APP_PORT=$FRONT_PORT &&
      export COMPOSE_PROJECT_NAME=$MICRO_SERVICE_FRONTEND &&

      docker network create micro_service || true &&

      docker compose down &&
      docker compose up -d"
  environment:
    name: development
    url: http://$SERVER_IP:${FRONT_PORT}
  only:
    changes:
      - "frontend/**/*"

deploy_products:
  stage: deploy
  tags:
    - linode
    - remote
    - shell
  before_script:
    - chmod og= $ID_RSA
  script:
    - scp -i $ID_RSA -o StrictHostKeyChecking=no ./docker-compose.yml $SERVER_USER@$SERVER_IP:/home/dabiko
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "
      docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY &&

      docker pull $PRODUCTS_TAG_COMMIT &&
      docker container rm -f $CI_REGISTRY_IMAGE || true &&

      export DC_IMAGE_NAME=$CI_REGISTRY_IMAGE &&
      export DC_IMAGE_TAG=$PRODUCTS_TAG_COMMIT &&
      export DC_APP_PORT=$PRODUCTS_PORT &&
      export COMPOSE_PROJECT_NAME=$MICRO_SERVICE_PRODUCTS &&

      docker network create micro_service || true &&

      docker compose down &&
      docker compose up -d"
  environment:
    name: development
    url: http://$SERVER_IP:${PRODUCTS_PORT}
  only:
    changes:
      - "products/**/*"

deploy_shopping_cart:
  stage: deploy
  tags:
    - linode
    - remote
    - shell
  before_script:
    - chmod og= $ID_RSA
  script:
    - scp -i $ID_RSA -o StrictHostKeyChecking=no ./docker-compose.yml $SERVER_USER@$SERVER_IP:/home/dabiko
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "
      docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY &&

      docker pull $SHOPPING_CART_TAG_COMMIT &&
      docker container rm -f $CI_REGISTRY_IMAGE || true &&

      export DC_IMAGE_NAME=$CI_REGISTRY_IMAGE &&
      export DC_IMAGE_TAG=$SHOPPING_CART_TAG_COMMIT &&
      export DC_APP_PORT=$CART_PORT &&
      export COMPOSE_PROJECT_NAME=$MICRO_SERVICE_SHOPPING_CART &&

      docker network create micro_service || true &&

      docker compose down &&
      docker compose up -d"
  environment:
    name: development
    url: http://$SERVER_IP:${CART_POR}
  only:
    changes:
      - "shopping-cart/**/*"
